// Mark Kamichoff
// kamicm@rpi.edu
// Homework 2

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <GL/glut.h>

#define INIT_W 960
#define INIT_H 720

void myinit(void);
void myReshape(GLsizei, GLsizei);
void key(unsigned char, int, int);
void tdrect(GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);

// globals
GLfloat win_width, win_height;

// misc -1 is keyb, 1 is mouse
int howrotate = -1;

// Motion Stuff
int tempx = 0.0;
int tempy = 0.0;

int ktempx = 5.0;
int ktempy = 5.0;

GLfloat temprotate = 0.0;
GLfloat temprotatespeed = 0.3;

// Main display function
void display(void)
{
	int i, j;
	float rx, temprx;
	char word[] = "Popcorn\0";

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	// Mouse
	if(howrotate == 1)
	{
		glRotatef(tempx, 0.0, 1.0, 0.0);
		glRotatef(tempy, 1.0, 0.0, 0.0);
	}
	// Keyboard
	else
	{
		glRotatef(ktempx, 0.0, 1.0, 0.0);
		glRotatef(ktempy, 1.0, 0.0, 0.0);
	}

	// The Grass
	tdrect(-0.75, -0.01, 0.75, 0.75, 0, -0.75, 0.0, 0.5, 0.0);

	// Green things on the right and left side of the grass
	glTranslatef(-0.75, 0.0, 0.0);
	tdrect(0.0, 0.0, 0.0, 0.1, 0.1, -0.75, 0.0, 0.4, 0.0);
	glTranslatef(1.5, 0.0, 0.0);
	tdrect(0.0, 0.0, 0.0, -0.1, 0.1, -0.75, 0.0, 0.4, 0.0);
	glTranslatef(-0.75, 0.0, 0.0);

	// Popcorn stand
	tdrect(0.2, 0.0, 0.3, 0.4, 0.2, 0.0, 0.6, 0.0, 0.0);

	// Text that says "POPCORN"
	// Color cycles every second
	if(time(NULL) % 2)
		glColor3f(1.0, 1.0, 1.0);
	else
		glColor3f(0.5, 0.5, 1.0);

	// Make the text
	rx = 0.25;
	for(i=0; i<strlen(word); i++)
	{
		glRasterPos3f(rx, 0.1, 0.31);
		glutBitmapCharacter(GLUT_BITMAP_9_BY_15, word[i]);
		temprx = ((float)glutBitmapWidth(GLUT_BITMAP_9_BY_15, word[i]) * 2.0) / (float)win_width;
		rx += temprx;
	}

	// Glass box where people give out popcorn...ugh
	tdrect(0.22, 0.2, 0.28, 0.38, 0.3, 0.02, 0.6, 0.6, 1.0);

	// Hahaha, flag poles
	tdrect(0.73, 0.0, 0.1, 0.74, 0.8, 0.09, 0.5, 0.5, 0.5);
	glPushMatrix();
	tdrect(0.74, 0.6, 0.092, 0.9, 0.8, 0.098, 1.0, 0.0, 0.0);
	glPopMatrix();

	tdrect(-0.73, 0.0, 0.1, -0.74, 0.8, 0.09, 0.5, 0.5, 0.5);
	glPushMatrix();
	tdrect(-0.74, 0.6, 0.092, -0.58, 0.8, 0.098, 1.0, 0.0, 0.0);
	glPopMatrix();

	// Make an entrance or something
	tdrect(-0.5, 0.0, 0.5, -0.55, 0.65, 0.45, 0.6, 0.6, 0.6);
	tdrect(0.45, 0.0, 0.5, 0.5, 0.65, 0.45, 0.6, 0.6, 0.6);
	tdrect(-0.65, 0.65, 0.5, 0.6, 0.7, 0.45, 0.6, 0.6, 0.6);

	// Back
	tdrect(-0.5, 0.0, -0.5, -0.55, 0.65, -0.45, 0.6, 0.6, 0.6);
	tdrect(0.45, 0.0, -0.5, 0.5, 0.65, -0.45, 0.6, 0.6, 0.6);
	tdrect(-0.65, 0.65, -0.5, 0.6, 0.7, -0.45, 0.6, 0.6, 0.6);

	// Stuff to connect back to front
	tdrect(-0.5, 0.65, 0.49, -0.55, 0.69, -0.45, 0.6, 0.6, 0.6);
	tdrect(0.45, 0.65, 0.49, 0.5, 0.69, -0.45, 0.6, 0.6, 0.6);

	// Make the Ferris wheel ----------------------------------------------------------------
	
	for(i=0; i<2; i++)
	{
		glPushMatrix();
	
		glTranslatef(0.0, 0.3414, -0.6);
	
		glRotatef(temprotate, 0.0, 0.0, 1.0);
		temprotate += temprotatespeed;
	
		// First make the | and - parts of the wheel
		tdrect(-0.1, 0.2414, 0.0, 0.1, 0.2614, -0.02, 0.5, 0.5, 0.5);
		tdrect(-0.2414, -0.1, -0.02, -0.2614, 0.1, 0.0, 0.5, 0.5, 0.5);
		tdrect(0.2414, 0.1, -0.02, 0.2614, -0.1, 0.0, 0.5, 0.5, 0.5);
		tdrect(0.1, -0.2414, -0.02, -0.1, -0.2614, 0.0, 0.5, 0.5, 0.5);
	
		// Next make the / and \ parts of the wheel
		glPushMatrix();
		glTranslatef(-0.1, -0.2614, 0.0);
		glRotatef(45, 0.0, 0.0, 1.0);
		tdrect(0.0, 0.0, -0.02, 0.02, 0.2254, 0.0, 0.5, 0.5, 0.5);
		glPopMatrix();
	
		glPushMatrix();
		glTranslatef(0.08, -0.2504, 0.0);
		glRotatef(-45, 0.0, 0.0, 1.0);
		tdrect(0.0, 0.0, -0.02, 0.02, 0.2354, 0.0, 0.5, 0.5, 0.5);
		glPopMatrix();
	
		glPushMatrix();
		glTranslatef(0.2494, 0.09, 0.0);
		glRotatef(45, 0.0, 0.0, 1.0);
		tdrect(0.0, 0.0, -0.02, 0.02, 0.2254, 0.0, 0.5, 0.5, 0.5);
		glPopMatrix();
	
		glPushMatrix();
		glTranslatef(-0.2554, 0.105, 0.0);
		glRotatef(-45, 0.0, 0.0, 1.0);
		tdrect(0.0, 0.0, -0.02, 0.02, 0.2254, 0.0, 0.5, 0.5, 0.5);
		glPopMatrix();

		// Make the struts that stick out of the center
		for(j=0; j<8; j++)
//		for(j=0; j<16; j++)
		{
			glPushMatrix();
			glRotatef(-22.5-(j*45), 0.0, 0.0, 1.0);
//			glRotatef(-11.25-(j*22.5), 0.0, 0.0, 1.0);
			tdrect(-0.01, -0.01, -0.02, 0.01, 0.2554, 0.0, 0.5, 0.5, 0.5);
			glPopMatrix();
		}

		// Now make the carts
		if(!i)
		{
			glPushMatrix();
			glTranslatef(0.2414, 0.1, -0.05);
			glRotatef(-temprotate, 0.0, 0.0, 1.0);
			tdrect(-0.0375, -0.0375, 0.02, 0.0375, 0.0375, -0.04, 0.3, 0.4, 1.0);
			tdrect(0.0, 0.0, -0.01, 0.01, 0.1, 0.01, 0.0, 0.9, 0.5);
			glPushMatrix();
				glRotatef(temprotate*1.5, 0.0, 1.0, 0.0);
				tdrect(-0.01, 0.1, -0.035, 0.01, 0.14, 0.012, 1.0, 0.7, 0.7);
			glPopMatrix();
			glPopMatrix();

			glPushMatrix();
			glTranslatef(0.1, 0.2414, -0.05);
			glRotatef(-temprotate, 0.0, 0.0, 1.0);
			tdrect(-0.0375, -0.0375, 0.02, 0.0375, 0.0375, -0.04, 0.3, 0.2, 1.0);
			tdrect(0.0, 0.0, -0.01, 0.01, 0.1, 0.01, 0.0, 0.9, 0.5);
			tdrect(-0.01, 0.1, -0.035, 0.01, 0.14, 0.012, 1.0, 0.7, 0.7);
			glPopMatrix();

			glPushMatrix();
			glTranslatef(-0.1, 0.2414, -0.05);
			glRotatef(-temprotate, 0.0, 0.0, 1.0);
			tdrect(-0.0375, -0.0375, 0.02, 0.0375, 0.0375, -0.04, 0.3, 0.4, 1.0);
			glPopMatrix();

			glPushMatrix();
			glTranslatef(-0.2414, 0.1, -0.05);
			glRotatef(-temprotate, 0.0, 0.0, 1.0);
			tdrect(-0.0375, -0.0375, 0.02, 0.0375, 0.0375, -0.04, 0.3, 0.6, 1.0);
			tdrect(0.0, 0.0, -0.01, 0.01, 0.1, 0.01, 0.0, 0.9, 0.5);
			tdrect(-0.01, 0.1, -0.035, 0.01, 0.14, 0.012, 1.0, 0.7, 0.7);
			glPopMatrix();

			glPushMatrix();
			glTranslatef(-0.2414, -0.1, -0.05);
			glRotatef(-temprotate, 0.0, 0.0, 1.0);
			tdrect(-0.0375, -0.0375, 0.02, 0.0375, 0.0375, -0.04, 0.3, 0.8, 1.0);
			glPopMatrix();

			glPushMatrix();
			glTranslatef(-0.1, -0.2414, -0.05);
			glRotatef(-temprotate, 0.0, 0.0, 1.0);
			tdrect(-0.0375, -0.0375, 0.02, 0.0375, 0.0375, -0.04, 0.3, 1.0, 1.0);
			tdrect(0.0, 0.0, -0.01, 0.01, 0.1, 0.01, 0.0, 0.9, 0.5);
			glPushMatrix();
				glRotatef(temprotate*3, 0.0, 1.0, 0.0);
			tdrect(-0.01, 0.1, -0.035, 0.01, 0.14, 0.012, 1.0, 0.7, 0.7);
			glPopMatrix();
			glPopMatrix();

			glPushMatrix();
			glTranslatef(0.1, -0.2414, -0.05);
			glRotatef(-temprotate, 0.0, 0.0, 1.0);
			tdrect(-0.0375, -0.0375, 0.02, 0.0375, 0.0375, -0.04, 0.3, 0.8, 1.0);
			tdrect(0.0, 0.0, -0.01, 0.01, 0.1, 0.01, 0.0, 0.9, 0.5);
			tdrect(-0.01, 0.1, -0.035, 0.01, 0.14, 0.012, 1.0, 0.7, 0.7);
			glPopMatrix();

			glPushMatrix();
			glTranslatef(0.2414, -0.1, -0.05);
			glRotatef(-temprotate, 0.0, 0.0, 1.0);
			tdrect(-0.0375, -0.0375, 0.02, 0.0375, 0.0375, -0.04, 0.3, 0.6, 1.0);
			glPopMatrix();
		}

		glPopMatrix();
		glTranslatef(0.0, 0.0, -0.1);
	}

	// Now make the structure
	glPushMatrix();
	glTranslatef(-0.005, 0.0, -0.4);
	tdrect(0.0, 0.0, 0.0, 0.02, 0.3414, 0.02, 0.5, 0.5, 0.5);

	if(time(NULL) % 2)
		tdrect(0.005, 0.325, 0.02, 0.015, 0.34, 0.03, 0.2, 0.2, 1.0);
	else
		tdrect(0.005, 0.325, 0.02, 0.015, 0.34, 0.03, 1.0, 0.2, 0.2);

	glPopMatrix();

	glPushMatrix();
	glTranslatef(-0.005, 0.0, -0.54);
	tdrect(0.0, 0.0, 0.0, 0.02, 0.3414, 0.02, 0.5, 0.5, 0.5);

	if(time(NULL) % 2)
		tdrect(0.005, 0.325, 0.0, 0.015, 0.34, -0.01, 1.0, 0.2, 0.2);
	else
		tdrect(0.005, 0.325, 0.0, 0.015, 0.34, -0.01, 0.2, 0.2, 1.0);

	glPopMatrix();

	// Angled thingies
	glPushMatrix();
	glTranslatef(-0.125, 0.0, -0.4);
	glRotatef(-23, 0.0, 0.0, 1.0);
	tdrect(0.0, 0.0, 0.0, -0.025, 0.3636, 0.02, 0.5, 0.5, 0.5);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(0.125, 0.0, -0.4);
	glRotatef(23, 0.0, 0.0, 1.0);
	tdrect(0.025, 0.0, 0.0, 0.0, 0.3636, 0.02, 0.5, 0.5, 0.5);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(-0.125, 0.0, -0.54);
	glRotatef(-23, 0.0, 0.0, 1.0);
	tdrect(0.0, 0.0, 0.0, -0.025, 0.3636, 0.02, 0.5, 0.5, 0.5);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(0.125, 0.0, -0.54);
	glRotatef(23, 0.0, 0.0, 1.0);
	tdrect(0.025, 0.0, 0.0, 0.0, 0.3636, 0.02, 0.5, 0.5, 0.5);
	glPopMatrix();

	// Done ----------------------------------------------------------------

	glutSwapBuffers();
}

// generic resize function, scales to W x H
void myReshape(GLsizei w, GLsizei h)
{
	win_width = w;
	win_height = h;

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glViewport(0,0,win_width,win_height);
	glClearColor(0.0, 0.0, 0.0,0.0);
	glClear(GL_COLOR_BUFFER_BIT);
	display();
	glutSwapBuffers();
}

// generic initialization routine
void myinit(void)
{
	glViewport(0, 0, win_width, win_height);
	glMatrixMode(GL_PROJECTION);
	glEnable(GL_DEPTH_TEST);
	glLoadIdentity();
	glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0);
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glClear(GL_COLOR_BUFFER_BIT);
	glutSwapBuffers();
}

void root_menu(int id)
{
	// Dummy Function
	if(id == 1)
		exit(0);
}

// If we type a key on the keyboad
void key(unsigned char k, int x, int y)
{
	// Exits
	if(k == 'q')
		exit(0);
	else if(k == 'r')
		howrotate *= -1;
	else
		printf("Key '%c' not bound\n", k);
}

void skey(unsigned char k, int x, int y)
{
	if(k == GLUT_KEY_LEFT)
		ktempx--;
	else if(k == GLUT_KEY_RIGHT)
		ktempx++;
	else if(k == GLUT_KEY_UP)
		ktempy++;
	else if(k == GLUT_KEY_DOWN)
		ktempy--;
	else if(k == GLUT_KEY_PAGE_UP)
		temprotatespeed += 0.1;
	else if(k == GLUT_KEY_PAGE_DOWN)
		temprotatespeed -= 0.1;
	else
		printf("Special key not bound\n");
}

void mouse_passive(int x, int y)
{
	y = win_height - y;

	tempx = x;
	tempy = y;
}

// Main function
int main(int argc, char **argv)
{
	// set the global width and height initially to the default window size
	win_width = INIT_W;
	win_height = INIT_H;
		
	// glut stuff and create the menus
	
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize(INIT_W, INIT_H);
	glutCreateWindow("Prolixium Amusement Park");

	glutDisplayFunc(display);
	glutIdleFunc(display);

	glutCreateMenu(root_menu);
	glutCreateMenu(root_menu);
	glutAddMenuEntry("Quit This Nonsense", 1);

	// right click for the menu
	glutAttachMenu(GLUT_RIGHT_BUTTON);

	myinit();

	glutReshapeFunc(myReshape);
	glutKeyboardFunc(key);
	glutSpecialFunc(skey);
	glutPassiveMotionFunc(mouse_passive);

	glutMainLoop();

	return 0;
}
